<?php

namespace JobeetBundle\Repository;

use Symfony\Component\Config\Definition\Exception\Exception;

/**
 * JobRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class JobRepository extends \Doctrine\ORM\EntityRepository
{

	public function getActiveJobs ($category_id = null,$max = null){

		$qb = $this->createQueryBuilder('j')
		->where('j.expiresAt > :date')
		->andWhere('j.isActivated = 1 ')
		->setParameter('date', date('Y-m-d H:i:s' , time()))
		->orderBy('j.expiresAt','DESC');

		if( !is_null($category_id) )
			$qb->setMaxResults($max);

		if( !is_null($category_id) ){
			$qb->andWhere('j.category = :category_id')
			->setParameter('category_id', $category_id);
		}

		$query = $qb->getQuery();
		
		return $query->getResult();
	}




	public function getActiveJob($id)
	{
	  $query = $this->createQueryBuilder('j')
	    ->where('j.id = :id')
	    ->setParameter('id', $id)
	    ->andWhere('j.expiresAt > :date')
	    ->andWhere('j.isActivated = 1 ')
	    ->setParameter('date', date('Y-m-d H:i:s', time()))
	    ->setMaxResults(1)
	    ->getQuery();
	 
	  try {
	    $job = $query->getSingleResult();

	  } catch (\Doctrine\Orm\NoResultException $e) {
	 	throw new Exception("Offre d'emploi introuvable", 1);
	 	
	    $job = null;
	  }
	 
	  return $job;
	}


}
